/*
*******************************************************************************
**
**  This device driver was created by Applilet2 for 78K0/Kx2
**  8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002 - 2010
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	 main.c
**  Abstract :	This file implements main function.
**  APIlib :	Applilet2 for 78K0/Kx2 V2.41 [29 Apr. 2008]
**
**  Device :	uPD78F0515_48
**
**  Compiler :	CC78K0
**
**  Creation date:	2010/06/07
**  
*******************************************************************************
*/

/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "Port.h"
#include "System.h"
/* Start user code for include definition. Do not edit comment generated here */
/* End user code for include definition. Do not edit comment generated here */
#include "user_define.h"

/*
*******************************************************************************
**  Global define
*******************************************************************************
*/
/* Start user code for global definition. Do not edit comment generated here */
/* End user code for global definition. Do not edit comment generated here */


/*
**-----------------------------------------------------------------------------
**
**	Abstract:
**		This function  implements main function.
**
**	Parameters:
**		None
**
**	Returns:
**		None
**
**-----------------------------------------------------------------------------
*/
unsigned int	mhz_no;
unsigned int	mhz_sub;
unsigned int	out_volt_data;


unsigned int	adj;
unsigned char	led;
unsigned char	ledb;

unsigned int	preset[5];
unsigned int	preset_volt[5];



void	wait_time(unsigned int time)
{
	while(time!=0){
		time--;
	}
}
void	preset_set(void)
{
	preset[4]=13000;
	preset[0]=13125;
	preset[1]=13145;
	preset[2]=13155;
	preset[3]=13195;
	
	preset_volt[4]=1450;
	preset_volt[0]=2038;
	preset_volt[1]=2128;
	preset_volt[2]=2185;
	preset_volt[3]=2378;
	
}
/*---------- VOLTAGE  ----------*/
void	dac_out_ch1(unsigned int data)
{
unsigned int 	d0;
unsigned char	d1;
unsigned char	i;

	P7.3=0;
	P7.4=1;
	d0=data << 4;
	d1=0x20;
	P7.4=0;
	
	for(i=0;i<8;i++){
		if((d1 & 0x80)==0x80){
			P7.5=1;
		}
		else{
			P7.5=0;
		}
		P7.3=1;
		d1=d1 << 1;
		P7.3=0;
	}
	
	for(i=0;i<16;i++){
		if((d0 & 0x8000)==0x8000){
			P7.5=1;
		}
		else{
			P7.5=0;
		}
		P7.3=1;
		d0=d0 << 1;
		P7.3=0;
	}
	P7.4=1;
	P7.5=0;
}
void	dac_out_ch2(unsigned int data)
{
unsigned int 	d0;
unsigned char	d1;
unsigned char	i;

	P7.3=0;
	P7.4=1;
	d0=data << 4;
	d1=0x21;
	P7.4=0;
	
	for(i=0;i<8;i++){
		if((d1 & 0x80)==0x80){
			P7.5=1;
		}
		else{
			P7.5=0;
		}
		P7.3=1;
		d1=d1 << 1;
		P7.3=0;
	}
	
	for(i=0;i<16;i++){
		if((d0 & 0x8000)==0x8000){
			P7.5=1;
		}
		else{
			P7.5=0;
		}
		P7.3=1;
		d0=d0 << 1;
		P7.3=0;
	}
	P7.4=1;
	P7.5=0;
}


void	vol_out1(unsigned int volt)
{
	dac_out_ch1(volt);		/* DAC1 CH A */
}
void	volt_up1(void)
{
	out_volt_data++;
	if(out_volt_data>=4096){
		out_volt_data=4095;
	}
}
void	volt_down1(void)
{
	if(out_volt_data>0){
		out_volt_data--;
	}
}
void	vol_out2(unsigned int volt)
{
	dac_out_ch2(volt);		/* DAC1 CH B */
}

/*----------  MHZ    ----------*/
void	mhz_inc(void)
{
	mhz_no=mhz_no+5;
	if(mhz_no==13505){mhz_no=12700;}
}

void	mhz_dec(void)
{
	mhz_no=mhz_no-5;
	if(mhz_no==12695){mhz_no=13500;}
}
void	mhz_inc_10(void)
{
	mhz_no=mhz_no+50;
	if(mhz_no>=13505){mhz_no=12700;}
}

void	mhz_dec_10(void)
{
	mhz_no=mhz_no-50;
	if(mhz_no<=12695){mhz_no=13500;}
}

void	mhz_set(void)
{
unsigned long data;
unsigned int i;

	data=0;
	for(i=0;i<5;i++){
		if(mhz_no==preset[i]){
			data=(unsigned long) preset_volt[i];
		}
	}
	if(data==0){
		data=(unsigned long)mhz_no;
		data=((data-12700)*452+38397)/100;
	}
	out_volt_data=(unsigned int)data;
	vol_out1(out_volt_data);
}
/*----------- DATA INPUT ----------*/
unsigned int freq_count_in(void)
{
unsigned int freq1,freq2;
unsigned int f_sub1,f_sub2;
unsigned int d0,d1,d2,d3,d4;
unsigned char port1,port2,port6,port3,port0,port4;
unsigned char port1b,port2b,port6b,port3b,port0b,port4b;


	port1=P1;port2=P2;port6=P6;port3=P3;port0=P0;port4=P4;
	port1b=P1;port2b=P2;port6b=P6;port3b=P3;port0b=P0;port4b=P4;
	
	d0=((port1 & 0xf0)>>4);
	d1=(port2 & 0x0f);
	d2=((port2 & 0xf0)>>4);
	d3=(port6 & 0x0f);
	d4=(port3 & 0x08)>>3;
	f_sub1=(port0 & 0x03)+((port4 & 0x03)<<2);

	freq1=d0+d1*10+d2*100+d3*1000+d4*10000;

	d0=((port1b & 0xf0)>>4);
	d1=(port2b & 0x0f);
	d2=((port2b & 0xf0)>>4);
	d3=(port6b & 0x0f);
	d4=(port3b & 0x08)>>3;
	f_sub2=(port0b & 0x03)+((port4b & 0x03)<<2);
	
	freq2=d0+d1*10+d2*100+d3*1000+d4*10000;

	freq1=(freq1+freq2)/2;
	mhz_sub=(f_sub1+f_sub2)/2;

	return freq1;
}

/*----------- LED -----------*/
void	led_out(void)
{
	if(led==ledb){return;}
	ledb=led;
	switch(led){
		case 0:P3.0=1;break;
		case 1:P3.0=0;break;
	}
}



/*---------- MAIN -----------*/
void  main( void )
{
unsigned int	freq_mhz;
unsigned int	freq_mhz_b;
unsigned int	sub;
unsigned char	sw1_key;
unsigned char	sw1_rep;
unsigned char	sw1_cnt;
unsigned char	preset_no;

	out_volt_data=0;
	preset_no=0;
	led=0;
	ledb=0;

	sw1_key=0;sw1_rep=0;sw1_cnt=0;

	freq_mhz_b=0;
	freq_mhz=0;
	adj=0;sub=0;
	
	preset_set();

	mhz_no=preset[preset_no];

	mhz_set();

	/* Start user code. Do not edit comment generated here */
	while (1) {
	/* key scan 1 */
		if (P1.0==0){
				sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
			sw1_cnt=0;
		}
		/*------------------*/



		if(freq_mhz!=freq_mhz_b){
			freq_mhz_b=freq_mhz;
		}
		else{
			wait_time(2000);
		}


		if(freq_mhz>(mhz_no+3)){adj=0;}
		if(freq_mhz<(mhz_no-3)){adj=0;}

		if(adj==0){
		/*---------------------*/
		freq_mhz=freq_count_in();
		if(freq_mhz==mhz_no){
			switch(mhz_sub){
				case 9:
				case 8:
				case 7:
				case 6:
				case 5:
				case 4:
				case 3:	volt_down1();
						vol_out1(out_volt_data);
						adj=50;
						led=0;led_out();
						break;
				case 2:	volt_down1();
						vol_out1(out_volt_data);
						adj=100;
						led=0;led_out();
						break;
				case 1:	/*volt_down1();
						vol_out1(out_volt_data);
						adj=200;
						led=0;led_out();*/
						adj=100;
						led=1;led_out();
						break;
				case 0: adj=100;
						led=1;led_out();
						break;
			}
		}
		if(freq_mhz==(mhz_no+1)){
			volt_down1();
			vol_out1(out_volt_data);
			adj=50;
			led=0;led_out();
		}
		if(freq_mhz==(mhz_no-1)){
			switch(mhz_sub){
				case 9:	/*volt_up1();
						vol_out1(out_volt_data);
						adj=200;*/
						adj=100;
						led=1;led_out();
						break;
				case 8:	volt_up1();
						vol_out1(out_volt_data);
						adj=100;
						led=0;led_out();
						break;
				case 7:
				case 6:
				case 5:
				case 4:
				case 3:
				case 2:
				case 1:
				case 0:	volt_up1();
						vol_out1(out_volt_data);
						adj=50;
						led=0;led_out();
						break;
			}
		}
		if(freq_mhz==(mhz_no+2)){
			volt_down1();
			vol_out1(out_volt_data);
			adj=20;
			led=0;led_out();
		}
		if(freq_mhz==(mhz_no-2)){
			volt_up1();
			vol_out1(out_volt_data);
			adj=20;
			led=0;led_out();
		}
		if(freq_mhz==(mhz_no+3)){
			volt_down1();
			vol_out1(out_volt_data);
			adj=10;
			led=0;led_out();
		}
		if(freq_mhz==(mhz_no-3)){
			volt_up1();
			vol_out1(out_volt_data);
			adj=10;
			led=0;led_out();
		}

		if(freq_mhz>(mhz_no+3)){
			volt_down1();
			vol_out1(out_volt_data);
			adj=5;
			led=0;led_out();
		}
		if(freq_mhz<(mhz_no-3)){
			volt_up1();
			vol_out1(out_volt_data);
			adj=5;
			led=0;led_out();
		}
		/*-----------------------*/
		}
		else{
			adj--;
		}
		/*-------------------*/

	/* key scan 2 */
		if ((P1.0==0)&(sw1_key==0)){
			sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
			sw1_cnt=0;
		}
		/*------------------*/

	/* key action */
	
		if((sw1_key==0)&(sw1_rep==0)){
			sw1_rep=1;
			preset_no++;
			if(preset_no>4){preset_no=0;}
			mhz_no=preset[preset_no];
			mhz_set();
		}

	}
	/* End user code. Do not edit comment generated here */
}

/* Start adding user code. Do not edit comment generated here */
/* End user code adding. Do not edit comment generated here */



